# -*- encoding: utf-8 -*-
##############################################################################
# Copyright (c) 2011 OpenERP Venezuela (http://openerp.com.ve)
# All Rights Reserved.
# Programmed by: Israel Fermín Montilla  <israel@openerp.com.ve>
# Designed by: Moisés López <moylop260@gmail.com>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
###############################################################################
from osv import osv
from osv import fields


class fiscal_printing_client(osv.osv):
    _name = 'fiscal.printing.client'
    _description = """Server-Side fiscal printing client for OpenERP"""

    def get_config_user(self, cr, uid, uid2, context=None):
        ids = self.search(cr, uid, [('user_id', '=', uid2)])
        config = self.browse(cr, uid, ids)[0]
        return config

    def get_config_ip(self, uid, ids, context=None):
        pass

    _columns = {
            "name": fields.char("IP Address", size=15, required=True, help="Client's IP Address, go to a command line terminal and execute ipconfig /all if using windows or ifconfig -a if using linux"),
            "mac_address": fields.char("MAC Address", size=17, required=True, help="Client's physical address, go to a command line terminal and execute ipconfig /all if using windows or ifconfig -a if using linux"),
            "port": fields.char("Port", size=12, required=True, help="Port where the fiscal module is listening"),
            "user_id": fields.many2one("res.users", "User", required=True, help="User related to this station, currently used to discriminate server responses"),
            "company_id": fields.many2one("res.company", "Company", help="Related company where this station belongs"),
            "driver": fields.selection([
                    ('bematech_4000fi', 'Bematech 4000 FI'),
                    ('options', 'Options'),
                    ('by', 'by'), 
                    ('now', 'Now'),
                ], "Driver", required=True, help="Printer driver used for this client"),
        }

    _defaults = {
            "user_id": lambda obj, cr, uid, context: uid,
            "driver": lambda *a: 'bematech_4000fi',
        }
fiscal_printing_client()
