# -*- encoding: utf-8 -*-
##############################################################################
# Copyright (c) 2011 OpenERP Venezuela (http://openerp.com.ve)
# All Rights Reserved.
# Programmed by: Israel Fermín Montilla  <israel@openerp.com.ve>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
###############################################################################
from osv import osv
from osv import fields
from tools.translate import _

class fiscal_printer_tax(osv.osv):
    _name = 'fiscal.printer.tax'
    _description= 'Mapping model from account.tax to fiscal.printing.client'
    _columns = {
        "name": fields.char("Printing Code", size=2, required=True, help="Two digits code which represents the corresponding tax on the printer recordi, this is the corresponding code that appears on the generated file when configuring the taxes on printer"),
        "company_id": fields.many2one("res.company", "Company", help="Company where this configuration applies"),
        "tax_id": fields.many2one(
            "account.tax",
            required=True,
            string="Tax",
            help="Tax which corresponds with this printer code",
        ),
        "client_ids": fields.many2many(
            'fiscal.printing.client',
            'rel_client_tax_code',
            'tax_code_id',
            'client_id',
            'Clients with this Configuration',
            help="Clients that has this tax configuration on their printers for this tax"
        ),
    }
fiscal_printer_tax()

class fiscal_printer_client_in(osv.osv):
    _inherit = 'fiscal.printing.client'
    _columns = {
        "tax_code_ids": fields.many2many(
            'fiscal.printer.tax',
            'rel_client_tax_code',
            'client_id',
            'tax_code_id',
            'Available Taxes',
            help='Available taxes to be configured on this client',
        ),
    }
fiscal_printer_client_in()
