# -*- encoding: utf-8 -*-
##############################################################################
# Copyright (c) 2011 OpenERP Venezuela (http://openerp.com.ve)
# All Rights Reserved.
# Programmed by: Israel Fermín Montilla  <israel@openerp.com.ve>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
###############################################################################
from osv import osv
from osv import fields
import netsvc
import base64
from tools.translate import _

class wizard_pos_fp_bematech_4000fi_sale(osv.osv_memory):
    _name = "wizard.print.invoice.pos"

    def check_driver(self, cr, uid, ids, context):
        pass

    def _create_report(self, cr, uid, context):
        driver_name = self._get_driver(cr, uid, context) or False
        if not driver_name:
            raise osv.except_osv(_('Error !'), _('There is no driver configured for this cashier. Please, call your manager.'))
        report_name = "pos_fp_%s.%s_sale" % (driver_name, driver_name)
        service = netsvc.LocalService("report."+report_name)
        (result, format) = service.create(cr, uid, context['active_ids'], {'model': context['active_model']}, {})
        return base64.encodestring(result)

    def _get_driver(self, cr, uid, ids):
        obj = self.pool.get('fiscal.printing.client').browse(cr, uid, self.pool.get('fiscal.printing.client').search(cr, uid, [('user_id', '=', uid)]))
        try:
            driver_name = obj[0].driver
        except Exception, e:
            raise osv.except_osv(_('Error !'), _('There is no driver configured for this cashier. Please, call your manager.'))
        return driver_name

    _columns = {
            'driver': fields.char("Driver", 64, readonly=True),
            'report_code.pyfiscal': fields.binary("Report", readonly=True),
        }

    _defaults = {
            'driver': lambda self, cr, uid, ids: self._get_driver(cr, uid, ids),
            'report_code.pyfiscal': lambda self, cr, uid, context: self._create_report(cr, uid, context),
        }
wizard_pos_fp_bematech_4000fi_sale()
